#Copyright (C) 2011 Daniel Wilkins
#This file is part of tvm
#Tvm is free software: you can redistribute it and/or modify
#   it under the terms of the GNU General Public License as published by
#   the Free Software Foundation, either version 3 of the License, or
#   (at your option) any later version.
#
#    This program is distributed in the hope that it will be useful,
#    but WITHOUT ANY WARRANTY; without even the implied warranty of
#    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
#    GNU General Public License for more details.
#
#    You should have received a copy of the GNU General Public License
#    along with this program.  If not, see <http://www.gnu.org/licenses/>.


@mem = (0, 2, 0,  4, 1, 2, 5, 0, 99);
$pc = 0;
$cur = $mem[$pc];
$flagReg = "";# null is "", e is equal, n is not equal, g is greater than, l is less than

sub vm_nop
{
    print("nop!\n");
}

sub vm_jmp
{
    print("jmp!\n");
    my $dest = shift;    my $dest = shift;
    $pc = $dest;
}

sub vm_mov
{
    print("mov!\n");
    my $dest = shift;
    my $src = shift;

    $mem[$dest] = $src;
}

sub vm_dmp
{
    print("dumping core!\n@mem\n");
}

sub vm_cmp
{
    print("comparing\n");
    my $ptr = shift;
    my $comp = shift;

    if ($mem[$ptr] == $comp)
    {
	$flagReg = "e";
    }
    elsif ($mem[$ptr] > $comp)
    {
	$flagReg = "g";
    }
    elsif ($mem[$ptr] < $comp)
    {
	$flagReg = "l";
    }
}

sub vm_je
{
    print("jeing\n");
    $dest = shift;

    if($flagReg eq "e")
    {
	print("equal\n");
	$pc = $dest;
	$flagReg = "";
    }
}
while ($cur != 99)
{
    if ($cur == 0)
    {
	vm_nop();
    }
    elsif ($cur == 1)
    {
	$pc += 1;
	vm_jmp($mem[$pc]);
    }
    elsif ($cur == 2)
    {
	$pc += 1;
	my $dest = $mem[$pc];
	$pc += 1;

	vm_mov($dest, $mem[$pc]);
    }
    elsif ($cur == 3)
    {
	vm_dmp();
    }
    elsif ($cur == 4)
    {
	$pc += 1;
	my $ptr = $mem[$pc];
	$pc += 1;
	vm_cmp($ptr, $mem[$pc]);
    }
    elsif ($cur == 5)
    {
	$pc += 1;
	vm_je($mem[$pc]);
    }

    $pc += 1;
    $cur = $mem[$pc];
}
